2016/10の機能追加でPC用アプリ(flash)が更新された
radiko.jp
以前のスクリプトの修正
radikoの仕様変更で録音ができなくなる問題を修正 | 忘れたらググればいい
radikoの録音の失敗する問題に応急処置 | 忘れたらググればいい
playerurl=http://radiko.jp/apps/js/flash/myplayer-release.swfに変更
X-Radiko-App: pc_tsに変更
X-Radiko-App-Version: 4.0.0に変更
/opt/local/bin/swfextract -b 12 /dev/stdin -o /dev/stdoutに変更
全変更を適用したのが以下
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
#!/bin/sh
#playerurl=http://radiko.jp/player/swf/player_3.0.0.01.swf
#playerurl=http://radiko.jp/player/swf/player_4.1.0.00.swf
playerurl=http://radiko.jp/apps/js/flash/myplayer-release.swf
#
# access auth1_fms
#
auth1_fms=`/usr/local/bin/wget -q \
--header="pragma: no-cache" \
--header="X-Radiko-App: pc_ts" \
--header="X-Radiko-App-Version: 4.0.0" \
--header="X-Radiko-User: test-stream" \
--header="X-Radiko-Device: pc" \
--post-data='\r\n' \
--no-check-certificate \
--save-headers \
https://radiko.jp/v2/api/auth1_fms \
-O -`
if [ $? -ne 0 -o ! "${auth1_fms}" ]; then
echo "failed auth1 process" 1>&2
exit 1
fi
# get keydata
# get partial key
#
authtoken=`echo ${auth1_fms} | perl -ne 'print $1 if(/x-radiko-authtoken: ([\w-]+)/i)'`
offset=`echo ${auth1_fms} | perl -ne 'print $1 if(/x-radiko-keyoffset: (\d+)/i)'`
length=`echo ${auth1_fms} | perl -ne 'print $1 if(/x-radiko-keylength: (\d+)/i)'`
partialkey=`/usr/local/bin/wget -q -O - ${playerurl} 2>/dev/null | \
/opt/local/bin/swfextract -b 12 /dev/stdin -o /dev/stdout | \
dd bs=1 skip=${offset} count=${length} 2> /dev/null | \
/opt/local/bin/base64`
if [ $? -ne 0 -o ! "${partialkey}" ]; then
echo "failed auth1 process" 1>&2
exit 1
fi
#
# access auth2_fms
#
auth2_fms=`/usr/local/bin/wget -q \
--header="pragma: no-cache" \
--header="X-Radiko-App: pc_ts" \
--header="X-Radiko-App-Version: 4.0.0" \
--header="X-Radiko-User: test-stream" \
--header="X-Radiko-Device: pc" \
--header="X-Radiko-Authtoken: ${authtoken}" \
--header="X-Radiko-Partialkey: ${partialkey}" \
--post-data='\r\n' \
--no-check-certificate \
https://radiko.jp/v2/api/auth2_fms \
-O -`
if [ $? -ne 0 -o ! "${auth2_fms}" ]; then
echo "failed auth2 process" 1>&2
exit 1
fi
### echo "authentication success" 1>&2
areaid=`echo ${auth2_fms} | perl -ne 'print $1 if(/^([^,]+),/i)'`
### echo "areaid: ${areaid}" 1>&2
echo "${playerurl}" "${authtoken}"